function params_acq = gtAcqDefaultParameters(acq)
% GTACQDEFAULTPARAMETERS  Set the acuisition parameters not read from the
%                         xml file
%     params_acq = gtAcqDefaultParameters(acq)
%     ----------------------------------------
%
%     Version 001 15-05-2012 by LNervo
%       Splitted from gtLoadAcquisitionXML()


acq.true_detsizeu  = 2048;
acq.true_detsizev  = 2048;

% interlacing parameters
% try to guess whether the scan is interlaced
if exist([acq.name '0_0000.edf'], 'file')
    acq.interlaced_turns = true; % assume one extra turn is reasonable guess
    disp('This looks like an interlaced scan! Doubling nproj...')
    acq.nproj            = acq.nproj*2;
else
    acq.interlaced_turns = false;
end

% mono tuned during scan?
acq.mono_tune      = false;
% if we have a horizontal rotation axis we turn the images during the copying process
acq.rotation_axis  = 'vertical';
acq.distortion     = 'none';

%   deal with flips and rotations
% subsequently, deal with flips and rotations, scans without direct beam
acq.flip_images    = false;
acq.no_direct_beam = false;

% rotate images to the gt coordinate system !!! Help !!!
acq.rotation_direction = 'clockwise';

acq.rotu        = acq.xdet/2+0.5;   % Images will be shifted in gtCreateFullLive to have rotation axis in center...
acq.rotx        = acq.rotu;
acq.maxradius   = max(acq.xdet,acq.ydet)/2*sqrt(2);
acq.beamchroma  = 'mono';

% if it is 360degree data, we need a pair table
if strcmpi(acq.type, '360degree')
    % pair tablename can be derived from the scan name
    acq.pair_tablename  = [acq.name 'spotpairs'];
    acq.calib_tablename = [acq.name 'paircalib'];
end

params_acq = acq;

end % end of function
