function [im, info]=gtGetFullImage(n,varargin)

% GTGETFULLIMAGE  GET FULL IMAGE N
%                         
%     im = =gtGetFullImage(n,varargin)
%     -----------------------------------------------
%     Read full image n from 1_preprocessing/full/
%     Option second argument is parameters.  If this is passed in then
%     parameters.acq.dir will be used as the path.  Otherwise, the function
%     will assume you are in the parameters.acq.dir directory and work
%     relative to this.
%
%     INPUT:
%       n = image number
%       parameters {optional}
%
%     OUTPUT:
%      full image

if length(varargin)==1
    parameters=varargin{1};
    dir=parameters.acq.dir;
else
    dir=pwd;
end

[im, info] =  edf_read(fullfile(dir, '1_preprocessing/full', sprintf('full%04d.edf',n)));




