%try some ideas to match diff and ext spots automatically.
%this script has to start from the app.dir directory, otherwise it crashes

%Andy, 8/2006

function [output_point]=auto_find(struct_id,option,saveflag)


global app;



%get ext image

%  %create the summed ext image
%  ext=zeros(app.data.ext.ysize, app.data.ext.xsize);
%  for i=app.extspot(struct_id).ExtStartImage:app.extspot(struct_id).ExtEndImage
%    ext = ext + edf_read(sprintf('ext/ext%04d.edf',i));
%  end
%  ext=ext/(app.extspot(struct_id).EndImage-app.extspot(struct_id).StartImage+1);

%read maximum intensity ext image from full
ext = edf_read(sprintf('full/full%04d.edf',app.extspot(struct_id).MaxImage),app.bb.directbeam);

%  %get the difspot image, transpose
%  dif = edf_read(sprintf('difspot/difspot%05d.edf',app.extspot(struct_id).ID))';

%read max intensity difspot from full
dif = edf_read(sprintf('full/full%04d.edf',app.extspot(struct_id).MaxImage),app.extspot(struct_id).BoundingBox);


%calc centre of mass, area of difspot
com_x = sum(dif) * ([1:length(sum(dif))]') / sum(sum(dif));
com_y = (sum(dif')*[1:length(sum(dif'))]')/sum(sum(dif'));
area = length(find(dif~=0));

%ext - direct beam image of sample, containing extinction spots
%dif - diffraction spot image

close all

%   %attempt to reduce fringing at top and bottom in s5_dct1_
%   ext=roifill(ext,[1 471 471 1],[1 1 7 7]);
%   ext=roifill(ext,[1 471 471 1],[390 390 400 400]);
%   figure(1); imshow(ext,[]);
%   figure(2); imshow(dif,[]);
%   iptwindowalign(figure(1),'right',figure(2),'left')
%   iptwindowalign(figure(1),'top',figure(2),'top')



switch option
  case 'gradient'
    sfGradient
    %correlation of edge detection image

  case 'gradient2'%correlation of edge detection image
    sfGradient2
  case 'subtraction'
    sfSubtraction

end

  function sfGradient2
    %make dif spot gradient, threshold
    dif_med = gtImgMedianFilter2(dif, [5 5]);
    [dif_gradx,dif_grady]=gradient(dif_med);

    dif_grad = sqrt((dif_gradx).^2+(dif_grady).^2);
    grad_thresh = (mean(dif_grad(:))+1*std(dif_grad(:)));
    grad_thresh2 = max(dif_grad(:));

    dif_gradx_sign = sign(dif_gradx);
    dif_gradx_t1=abs(dif_gradx) > grad_thresh;
    dif_gradx_t1 = dif_gradx_sign.*dif_gradx_t1;

    dif_grady_sign = sign(dif_grady);
    dif_grady_t1=abs(dif_grady) > grad_thresh;
    dif_grady_t1 = dif_grady_sign.*dif_grady_t1;

    %make dif spot perimeter for display - snake input?
    dif_spot = dif_med > 0.1*max(dif_med(:));
    dif_spot_perimeter=double(bwperim(dif_spot));

    %median filter, find edges
    ext_med = gtImgMedianFilter2(ext, [9 9]);
    ext_edges=edge(ext_med,0.001);

    [ext_gradx,ext_grady]=gradient(ext_med);

    ext_gradx_sign = -sign(ext_gradx);
    ext_gradx = abs(ext_gradx);
    ext_gradx_t1=and(ext_gradx>grad_thresh, ext_gradx<grad_thresh2);
    ext_gradx_t1 = ext_gradx_sign.*ext_gradx_t1;

    ext_grady_sign = -sign(ext_grady);
    ext_grady = abs(ext_grady);
    ext_grady_t1=and(ext_grady>grad_thresh, ext_grady<grad_thresh2);
    ext_grady_t1 = ext_grady_sign.*ext_grady_t1;

    %pad dif_grad to size of ext to use correlate
    dif_maskx=zeros(size(ext));
    dif_maskx(1:size(dif_gradx_t1,1),1:size(dif_gradx_t1,2))=dif_gradx_t1;
    dif_masky=zeros(size(ext));
    dif_masky(1:size(dif_grady_t1,1),1:size(dif_grady_t1,2))=dif_grady_t1;

    dif_perim_mask=zeros(size(ext));
    dif_perim_mask(1:size(dif_gradx_t1,1),1:size(dif_gradx_t1,2))=dif_spot_perimeter;
    dif_spot_mask=zeros(size(ext));
    dif_spot_mask(1:size(dif_gradx_t1,1),1:size(dif_gradx_t1,2))=dif_spot;

    % do correlation
    cc_x=abs(ifft2(fft2(ext_gradx_t1).*conj(fft2(dif_maskx))));% from correlate.m
    cc_y=abs(ifft2(fft2(ext_grady_t1).*conj(fft2(dif_masky))));% from correlate.m

    cc= sqrt(cc_x.^2 + cc_y.^2);

    [tmp,tmp2] = max(cc(:));
    [tmp3,tmp4] = ind2sub(size(cc),tmp2);
    shift = [tmp3 tmp4];

    %apply shifts
    dif_perim_mask=roll(dif_perim_mask,shift(1),shift(2));
    dif_spot_mask=roll(dif_spot_mask,shift(1),shift(2));
    com_x = com_x + shift(2);
    com_y = com_y + shift(1);
    output_point = round([com_x com_y]); %where user would click in find_spots...

    % produce display
    figure(1)
    %set(1,'visible','off')
    imshow(dif,[]);

    figure(2)
    % set(2,'visible','off')
    clf
    h1=imshow(ext,[]);
    hold on
    h3=imagesc(cat(3,dif_perim_mask, zeros(size(dif_perim_mask)), zeros(size(dif_perim_mask))));
    set(h3,'alphadata',dif_perim_mask);
    plot(com_x, com_y, 'xr', 'markersize', 10)
    hold off
    drawnow
    global point
    title(num2str(struct_id))
    point(struct_id).x=com_x;
    point(struct_id).y=com_y;
    h_ax(1)=gca;

    % save if so requested
    if exist('saveflag','var') && saveflag==true
      fname=sprintf('/data/id19/graintracking/tmp/overnight%04d.jpg',struct_id);
      save('/data/id19/graintracking/tmp/overnight.mat','point')
      print(gcf,'-djpeg',fname)
    end

    if 1 % start snake stuff
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      % snake moves towards the light
      ext_snake=gtNormaliseImage(ext);
      keyboard
      disp(' Compute GVF ...');
      disp('Low rez gvf!');
      [u,v] = GVF(ext_snake, 0.2, 20);  % 0.2,80

      disp(' Nomalizing the GVF external force ...');
      mag = sqrt(u.^2+v.^2);
      px = u./(mag+1e-10); py = v./(mag+1e-10);

      % display the gradient of the edge map
      [fx,fy] = gradient(ext_snake);
      %     subplot(223); quiver(fx,fy);
      %     axis off; axis equal; axis 'ij';     % fix the axis
      %     title('edge map gradient');

      % display the GVF
      figure(3); quiver(px,py);
      hold on
      h4=imagesc(cat(3,dif_perim_mask, zeros(size(dif_perim_mask)), zeros(size(dif_perim_mask))));
      set(h4,'alphadata',dif_perim_mask);
      plot(com_x, com_y, 'xr', 'markersize', 10)
      hold off
      %     axis off; axis equal; axis 'ij';     % fix the axis
      %    title('normalized GVF field');
      h_ax(2)=gca;
      linkaxes(h_ax,'xy')
pause
      % snake deformation
      close all
      figure(1); clf
      colormap(gray);
      b=imagesc(ext_snake);
      set(b,'alphadata',0.5);
      hold on

      % find polygon that is equivalent to perim mask of difpot
      [y,x]=find(dif_perim_mask);
      [x,y]=gtOrderPerimeterPoints(x,y);  % sort them out properly

      snakedisp(x,y,'r.-')

      [x,y] = snakeinterp(x,y,20,0.5);


      elastic=0.15;
      rigid=0.5;
      viscous=0.3;
      force=-.05;  % positive if the spot is bright, negative if the spot is dark
      iter=5;
      for i=1:25,
        [x,y] = snakedeform(x,y,elastic,rigid,viscous,force,px,py,iter);
        [x,y] = snakeinterp(x,y,5,0.5);
        snakedisp(x,y,'r.-')
        title(['Deformation in progress,  iter = ' num2str(i*iter)])
        drawnow
      end

      %
      % NOTE:
      %
      % traditional snake and distance snake differed from GVF snake only
      %   by using different external force field. In order to produce the
      %   corresponding external force field, use the following (all
      %   assuming edge map f is in memory).
      %
      % traditional snake:
      %   f0 = gaussianBlur(f,1);
      %   [px,py] = gradient(f0);
      %
      % distance snake:
      %   D = dt(f>0.5);  % distance transform (dt) require binary edge map
      %   [px,py] = gradient(-D);
      %
      % [px,py] is the external force field in both cases
      %
      % balloon model using a different matlab function "snakedeform2"
      % instead of "snakedeform". The external force could be any force
      % field generated above.
      %
      % an example of using it is as follows
      %       [x,y] = snakedeform2(x,y, alpha, beta, gamma, kappa, kappap, px,py,2);
      % do a "help snakedeform2" for more details
      %



      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    end
  end

  function sfGradient
    %dif_norm=gtNormaliseImage(dif);
    %find perimeter of difspot
    %   dif_spot=dif_norm>0.1;
    dif_spot = gtImgMedianFilter2(dif, [5 5]);
    dif_spot = dif_spot > 0.1*max(dif_spot(:));
    dif_spot_perimeter=double(bwperim(dif_spot));

    %[gx,gy]=gradient(ext);
    %ext_grad=sqrt(gx.^2+gy.^2);

    %median filter, find edges
    ext_med = gtImgMedianFilter2(ext, [9 9]);
    ext_edges=edge(ext_med,0.001);

    [gradx,grady]=gradient(ext_med);
    ext_grad = sqrt((gradx).^2+(grady).^2);

    ext_grad_t1=ext_grad>(mean(ext_grad(:))+1*std(ext_grad(:)));

    %pad dif_grad to size of ext to use correlate
    dif_perim_mask=zeros(size(ext));
    dif_perim_mask(1:size(dif_spot_perimeter,1),1:size(dif_spot_perimeter,2))=dif_spot_perimeter;


    dif_fullsize=zeros(size(ext));
    dif_fullsize(1:size(dif,1),1:size(dif,2))=dif;



    %do correlation
    shift = round(correlate(ext_edges,dif_perim_mask));
    dif_perim_mask2=roll(dif_perim_mask,shift(1),shift(2));
    dif_fullsize=roll(dif_fullsize,shift(1),shift(2));

    shift2=round(correlate(ext_grad_t1,dif_perim_mask));
    tmp2=roll(dif_perim_mask,shift2(1),shift2(2));

    %%%%%%%%%%
    if 0
      % cross-correlate BW and T_offset to recover offset
      cc = normxcorr2(dif_spot_perimeter,ext_edges);
      [max_cc, imax] = max(abs(cc(:)));
      [ypeak, xpeak] = ind2sub(size(cc),imax(1));
      xpeak=xpeak-size(dif_spot_perimeter,2);
      ypeak=ypeak-size(dif_spot_perimeter,1);
      dif_perim_mask3=gtShift(dif_perim_mask,xpeak,-ypeak);
    end
    %%%%%%%%%

    com_x = com_x + shift(2);
    com_y = com_y + shift(1);
    output_point = round([com_x com_y]); %where user would click in find_spots...


    figure(1)
    clf
    h1=imshow(gtNormaliseImage(ext),[]);
    hold on
    h3=imagesc(tmp2);
    set(h3,'alphadata',0.3);
    hold off
    drawnow

  end
  function sfSubtraction

    dif=gtNormaliseImage(dif);
    ext=gtNormaliseImage(ext);

    ext = gtImgMedianFilter2(ext,[5 5]);

    %estimate centre of dif
    c_dif=(size(dif)./2);
    imshow(dif,[]);
    hold on
    plot(c_dif(2),c_dif(1),'xg');



    result = nlfilter(ext,size(dif),@calc_dif);

    dummy=find(result == min(result(:)));


    figure;
    imshow(ext,[]);
    hold on

    for i=1:length(dummy);

      col = ceil(dummy(i)/size(ext,1));
      row = dummy(i)-((col-1)*size(ext,1));

      col = col;%+c_dif(2);
      row = row;%+c_dif(1);

      plot(col,row,'xr');

    end
    function output = calc_dif(nhood)

      temp = (-nhood) + dif;
      temp = abs(temp);
      temp = sum(temp(:));
      output = temp;

    end

  end
end


