function[ir, sinogram ,angles, centres] = backpro_new(family,common)

load('parameters.mat');

%loop through the spots in the family
for i=1:length(family)

spotid = common(family(i)).ID;
angles(i) = 180*common(family(i)).MaxImage/app.nvue;

%determine which line of image is used for sinogram 
if i==1 
  sino_ypos = common(family(i)).ExtBoundingBox(2) + ceil(common(family(i)).ExtBoundingBox(4)/2);
end

%read line of extspot into sinogram
sinogram(i,:) = zeros(1,app.data.ext.xsize);
sino_xpos = common(family(i)).ExtBoundingBox(1);


% %work around bug in replaced spots
% if isempty(common(family(i)).Replaced)==1
   sino_xwidth = common(family(i)).ExtBoundingBox(3);
% else
%   sino_xwidth = common(family(i)).BoundingBox(3);
% end
% 
% 


extspot_ypos = sino_ypos - common(family(i)).ExtBoundingBox(2);

extspot = edfread(sprintf('extspot/extspot%05d.edf',spotid));
extspot_width = size(extspot);
extspot_width = extspot_width(2)-1;

if sino_xwidth ~= (extspot_width)
sprintf('warning: bounding box and spot edf size mismatch at common(%d), theta=%d',family(i),angles(i))
end

%read extspot width regardless of reported bounding box width
%prints warning on screen.
if extspot_ypos <= length(extspot)
  sinogram(i,sino_xpos:sino_xpos+extspot_width) = extspot(extspot_ypos,:);
  %do normalisation
  sinogram(i,:) = sinogram(i,:)./sum(sinogram(i,:));
else
  sprintf('warning: serious bounding box mismatch at common(%d), IGNORING!',family(i))
end
  
%else
%prob = family(i)
%keyboard
%end
  
end

%sort sinogram and angles by angle
temp = [angles' sinogram];
temp = sortrows(temp,1);
angles=temp(:,1);
temp(:,1)=[];
sinogram=temp;


%do backprojection with iradon

ir =1000000*iradon(sinogram', angles','Hamming');


%calculate centre of mass positions in sinogram for sine fit
pos=1:1:length(sinogram);

centres=pos*sinogram';
figure(2);
plot(angles,centres,'or')
hold on

figure(3);
imshow(ir,[])
app.handles.fig=figure(3);
set(app.handles.fig,'numbertitle','off','menubar','none');
set(app.handles.fig,'WindowButtonDownFcn',@sfMouseClick);


%pick a spot...
%xpos = input('(approx) x position of spot');
%ypos = input('(approx) y position of spot');

%calc phase and amplitude
centre = 331/2;
amp = sqrt((xpos-centre)^2+(ypos-centre)^2);
phase = atan((xpos-centre)/(ypos-centre))+pi()/2;%why the pi/2???
params0 = [amp phase];
dummy = 0:5:180;
dummy2 = sino_function(params0, dummy);
figure(2);
plot(dummy,dummy2,'-y')




%imtool(ir, [])

% 
% 
% 
% 
%       %for i=1:length(theta)
% 
%           %name=sprintf('rawsino%d.tif',n);
%           %p=imread(name)';
%           p=double(sinogram);
% 
%           len=size(p,1);
% 
%           keyboard
% 
%           %name=sprintf('C:/Program Files/ADCIS-AAI/Aphelion/extinction/angle%d.dat',grain);
%           %[theta,comx]=textread(name,'%s %s %*[^\n]','delimiter',',');
%           %theta=str2double(theta)/180*pi;
% 
%           %interp='linear';
%           interp='nearest neighbor';
%           N=len;
% 
% 
%           img = zeros(N);        % Allocate memory for the image.
% 
%       % Define the x & y axes for the reconstructed image so that the origin
%       % (center) is in the spot which RADON would choose.
%       xax = (1:N)-ceil(N/2);
%       x = repmat(xax, N, 1);    % x coordinates, the y coordinates are rot90(x)
%       y = rot90(x);
% 
%       costheta = cos(theta);
%       sintheta = sin(theta);
%       ctrIdx = ceil(len/2);     % index of the center of the projections
% 
%       % Zero pad the projections to size 1+2*ceil(N/sqrt(2)) if this
%       % quantity is greater than the length of the projections
%       imgDiag = 2*ceil(N/sqrt(2))+1;  % largest distance through image.
%       if size(p,1) < imgDiag
%          rz = imgDiag - size(p,1);  % how many rows of zeros
%          p = [zeros(ceil(rz/2),size(p,2)); p; zeros(floor(rz/2),size(p,2))];
%          ctrIdx = ctrIdx+ceil(rz/2);
%       end
% 
%       % Backprojection - vectorized in (x,y), looping over theta
%       if strcmp(interp, 'nearest neighbor')
%          for i=1:length(theta)
%             proj = p(:,i);
%             t = round(x*costheta(i) + y*sintheta(i));
%             img = img + proj(t+ctrIdx);
%          end
%       elseif strcmp(interp, 'linear')
%          for i=1:length(theta)
%             proj = p(:,i);
%             t = x.*costheta(i) + y.*sintheta(i);
%             a = floor(t);
%             img = img + (t-a).*proj(a+1+ctrIdx) + (a+1-t).*proj(a+ctrIdx);
%          end
%       elseif strcmp(interp, 'spline')
%          for i=1:length(theta)
%             proj = p(:,i);
%             taxis = (1:size(p,1)) - ctrIdx;
%             t = x.*costheta(i) + y.*sintheta(i);
%             projContrib = interp1(taxis,proj,t(:),'*spline');
%             img = img + reshape(projContrib,N,N);
%          end
%       end
% 
% 
%       name='back_projection_test.tif';
%       mat2gray(img,[0 255]);
%       imwrite(mat2gray(img,[0 255]),name)
%       %end
% 
%       imshow(img,[])
% 
% 
%       %%%
%       %%%  Sub-Function:  designFilter
%       %%%
% 
%       function filt = designFilter(filter, len, d)
%       % Returns the Fourier Transform of the filter which will be
%       % used to filter the projections
%       %
%       % INPUT ARGS:   filter - either the string specifying the filter
%       %               len    - the length of the projections
%       %               d      - the fraction of frequencies below the nyquist
%       %                        which we want to pass
%       %
%       % OUTPUT ARGS:  filt   - the filter to use on the projections
% 
% 
%       order = max(64,2^nextpow2(2*len));
% 
%       % First create a ramp filter - go up to the next highest
%       % power of 2.
% 
%       filt = 2*( 0:(order/2) )./order;
%       w = 2*pi*(0:size(filt,2)-1)/order;   % frequency axis up to Nyquist
% 
%       switch filter
%       case 'ram-lak'
%          % Do nothing
%       case 'shepp-logan'
%          % be careful not to divide by 0:
%          filt(2:end) = filt(2:end) .* (sin(w(2:end)/(2*d))./(w(2:end)/(2*d)));
%       case 'cosine'
%          filt(2:end) = filt(2:end) .* cos(w(2:end)/(2*d));
%       case 'hamming'
%          filt(2:end) = filt(2:end) .* (.54 + .46 * cos(w(2:end)/d));
%       case 'hann'
%          filt(2:end) = filt(2:end) .*(1+cos(w(2:end)./d)) / 2;
%       otherwise
%          error('Invalid filter selected.');
%       end
% 
%       filt(w>pi*d) = 0;                      % Crop the frequency response
%       filt = [filt' ; filt(end-1:-1:2)'];    % Symmetry of the filter
% 
% 
% 

end

function sfMouseClick(varargin)
pt = get(gca, 'currentpoint');
xpos = pt(1);
ypos = pt(2);
end
