function spot=gtGetSummedDifSpot_360(pair_id)
%returns the summed difspot image (saved as difspot%05d.edf)
%for 360 datasets, given a pair ID it returns the A difspot, if one exists,
%else the B difspot

parameters=[];
if isempty(parameters)
  disp('Loading parameter file')
  load('parameters.mat');
end
acq=parameters.acq;

%get the root of the pair name
pair_name=parameters.acq.pair_tablename;
pair_name(end-8:end)=[];

%is there an A difspot in the pair table?
  mysqlcmd = sprintf(['select !isnull(difAID), ifnull(difAID,difBID) from %s where pairID=%d'],...
    acq.pair_tablename,pair_id);
[A,difID]=mym(mysqlcmd);

if A %if the first half of the scan
  name=parameters.acq.difA_name;
  disp('reading difspot from A')
else
  name=parameters.acq.difB_name;
  disp('reading difspot from B')
end
path=sprintf('../%s/',name);


spot=edf_read(sprintf('%s2_difspot/difspot/difspot%05d.edf',path,difID));



end
