function [dif_maskx, dif_masky] = prepare_correlation_image_andytest(struct_id, grad_thresh, grad_thresh2)

%prepare image to be subtracted from subsequent correlation inputs
%ie - edge detected image of difspot, placed at extspot location,
%calculated with threshold values of the new difspot


global app;

trial = load('../../tmp/correlate150906.mat');
disp('HARD CODED ../../tmp/autofind_extspot')

%read max intensity difspot from full
dif = edf_read(sprintf('full/full%04d.edf',app.extspot(struct_id).MaxImage),app.extspot(struct_id).BoundingBox);

%calc centre of mass, area of difspot
com_x = sum(dif) * ([1:length(sum(dif))]') / sum(sum(dif));
com_y = (sum(dif')*[1:length(sum(dif'))]')/sum(sum(dif'));

%make dif spot gradient, threshold
dif_med = gtImgMedianFilter2(dif, [5 5]);
[dif_gradx,dif_grady]=gradient(dif_med);

dif_gradx_sign = sign(dif_gradx);
dif_gradx_t1=abs(dif_gradx) > grad_thresh;
dif_gradx_t1 = dif_gradx_sign.*dif_gradx_t1;

dif_grady_sign = sign(dif_grady);
dif_grady_t1=abs(dif_grady) > grad_thresh;
dif_grady_t1 = dif_grady_sign.*dif_grady_t1;

%com in extinction image can be read from anotherovernight structure

ext_com_x = trial.point(struct_id).x;
ext_com_y = trial.point(struct_id).y;
shift_x = ceil(ext_com_x - com_x);
shift_y = ceil(ext_com_y - com_y);

%make ext sized image, paste in dif spot...
dif_maskx = zeros(app.bb.directbeam(4), app.bb.directbeam(3));
dif_maskx(1:size(dif_gradx_t1,1),1:size(dif_gradx_t1,2))=dif_gradx_t1;

dif_masky = zeros(app.bb.directbeam(4), app.bb.directbeam(3));
dif_masky(1:size(dif_grady_t1,1),1:size(dif_grady_t1,2))=dif_grady_t1;

%roll mask to correct position
dif_maskx=roll(dif_maskx,shift_y,shift_x);
dif_masky=roll(dif_masky,shift_y,shift_x);

