function [gh]=gtGetHexagonalSymOp_sab()
% modif sabine
    load('parameters.mat');
    spacegroup = parameters.cryst.spacegroup ; 

    switch spacegroup
    case {663, 194, 167}

        %This function returns the  12 symmetry operators for the hexagonal crystal
        gh(1).g=[...
                1 0 0 0;...
                0 1 0 0;...
                0 0 1 0;...
                0 0 0 1] ;

        gh(2).g=[...
                0 0 1 0;...
                1 0 0 0;...
                0 1 0 0;...
                0 0 0 1];

        gh(3).g = [...
                0 1 0 0;...
                0 0 1 0;...
                1 0 0 0;...
                0 0 0 1];

        gh(4).g=[...
                1 0 0 0;...
                0 1 0 0;...
                0 0 1 0;...
                0 0 0 -1] ;

        gh(5).g=[...
                0 0 1 0;...
                1 0 0 0;...
                0 1 0 0;...
                0 0 0 -1];

        gh(6).g = [...
                0 1 0 0;...
                0 0 1 0;...
                1 0 0 0;...
                0 0 0 -1];

        gh(7).g=[...
                -1 0 0 0;...
                0 -1 0 0;...
                0 0 -1 0;...
                0 0 0 1] ;

        gh(8).g=[...
                0 0 -1 0;...
                -1 0 0 0;...
                0 -1 0 0;...
                0 0 0 1];

        gh(9).g = [...
                0 -1 0 0;...
                0 0 -1 0;...
                -1 0 0 0;...
                0 0 0 1];

        gh(10).g=[...
                -1 0 0 0;...
                0 -1 0 0;...
                0 0 -1 0;...
                0 0 0 -1] ;

        gh(11).g=[...
                0 0 -1 0;...
                -1 0 0 0;...
                0 -1 0 0;...
                0 0 0 -1];

        gh(12).g = [...
                0 -1 0 0;...
                0 0 -1 0;...
                -1 0 0 0;...
                0 0 0 -1];

        % temporary resurrection of the three component versions of these
        %disp('also returning three component versions of the sym operations')

        gh(1).g3 = [...
                1 0 0;...
                0 1 0;...
                0 0 1];

        % rotate 120 around z
        gh(2).g3 = [...
                cosd(120) sind(120) 0;...
                -sind(120) cosd(120) 0;...
                0 0 1];

        % rotate -120 around z
        gh(3).g3 = [...
                cosd(-120) sind(-120) 0;...
                -sind(-120) cosd(-120) 0;...
                0 0 1];

        % mirror normal to z
        gh(4).g3 = [...
                1 0 0;...
                0 1 0;...
                0 0 -1];

        % rotate 120 around z, mirror normal to z
        gh(5).g3 = [...
                cosd(120) sind(120) 0;...
                -sind(120) cosd(120) 0;...
                0 0 -1];

        % rotate -120 around z, mirror normal to z
        gh(6).g3 = [...
                cosd(-120) sind(-120) 0;...
                -sind(-120) cosd(-120) 0;...
                0 0 -1];

        % rotate 180 around z
        gh(7).g3 = [...
                -1 0 0;...
                0 -1 0;...
                0 0 1];

        % rotate 180 + 120 around z
        gh(8).g3 = [...
                -cosd(120) -sind(120) 0;...
                sind(120) -cosd(120) 0;...
                0 0 1];

        % rotate 180 - 120 around z
        gh(9).g3 = [...
                -cosd(-120) -sind(-120) 0;...
                sind(-120) -cosd(-120) 0;...
                0 0 1];

        % invert through origin
        gh(10).g3 = [...
                -1 0 0;...
                0 -1 0;...
                0 0 -1];

        % rotate 120 around z, and invert through origin
        gh(11).g3 = [...
                -cosd(120) -sind(120) 0;...
                sind(120) -cosd(120) 0;...
                0 0 -1];

        % rotate -120 around z, and invert through origin
        gh(12).g3 = [...
                -cosd(-120) -sind(-120) 0;...
                sind(-120) -cosd(-120) 0;...
                0 0 -1];

        %   
        % %%%%%% this is the second attempt - using rotation around y axis to
        % %%%%%% generate another 12 options, then keeping only the 12 proper
        % %%%%%% rotations (not inversions/ mirrors)
        % %%%%%% see Heinz and Neumann 1991 maybe
        % %ref
        % % hkil -> hkil
        % gh(1).g3 = [...
        %     1 0 0;
        %     0 1 0;
        %     0 0 1];
        % 
        % % rotate 120 around z
        % % hkil -> ihkl
        % gh(2).g3 = [...
        %     cosd(120) sind(120) 0;
        %     -sind(120) cosd(120) 0;
        %     0 0 1];
        % 
        % % rotate -120 around z
        % % hkil -> kihl
        % gh(3).g3 = [...
        %     cosd(-120) sind(-120) 0;
        %     -sind(-120) cosd(-120) 0;
        %     0 0 1];
        % 
        % % rotate 180 around y
        % % hkil -> ikh-l
        % gh(4).g3 = [...
        %     -1 0 0;
        %     0 1 0;
        %     0 0 -1];
        % 
        % % rotate 180 around y, 120 around z
        % % hkil -> ikh-l -> hik-l
        % gh(5).g3 = [...
        %     -cosd(120) sind(120) 0;
        %     sind(120) cosd(120) 0;
        %     0 0 -1];
        % 
        % % rotate 180 around y, -120 around z
        % % hkil -> ikh-l -> khi-l
        % gh(6).g3 = [...
        %     -cosd(-120) sind(-120) 0;
        %     sind(-120) cosd(-120) 0;
        %     0 0 -1];
        % 
        % % rotate 180 around z %%%% this I think is wrong?
        % % hkil ->  -h-k-i l
        % gh(7).g3 = [...
        %     -1 0 0;
        %     0 -1 0;
        %     0 0 1];
        % 
        % % rotate 180 + 120 around z %%%% this I think is wrong?
        % % hkil ->  -h-k-i l -> -i-h-k l
        % gh(8).g3 = [...
        %     -cosd(120) -sind(120) 0;
        %     sind(120) -cosd(120) 0;
        %     0 0 1];
        % 
        % % rotate 180 - 120 around z %%%% this I think is wrong?
        % % hkil ->  -h-k-i l -> -k -i -h l
        % gh(9).g3 = [...
        %     -cosd(-120) -sind(-120) 0;
        %     sind(-120) -cosd(-120) 0;
        %     0 0 1];
        % 
        % % rotate 180 around y, 180 around z %%%% this I think is wrong?
        % % hkil -> ikh-l ->  -i-k-h-l
        % gh(10).g3 = [...
        %     1 0 0;
        %     0 -1 0;
        %     0 0 -1];
        % 
        % % rotate 180 around y, then 180 + 120 around z
        % % hkil -> ikh-l ->  -i-k-h-l  ->  -h-i-k-l
        % gh(11).g3 = [...
        %     cosd(120) -sind(120) 0;
        %     -sind(120) -cosd(120) 0;
        %     0 0 -1];
        % 
        % % rotate 180 around y, then 180 - 120 around z
        % % hkil -> ikh-l ->  -i-k-h-l  ->  -k-h-i-l
        % gh(12).g3 = [...
        %     cosd(-120) -sind(-120) 0;
        %     -sind(-120) -cosd(-120) 0;
        %     0 0 -1];

    case {167} % {167} % trigonal symmetry
        % 6 operators, also return in 3 index format
        % however, this doesn't seem right when looking at the alumina
        % datasets... more work to do.

        %reference
        gh(1).g=[...
                1 0 0 0;...
                0 1 0 0;...
                0 0 1 0;...
                0 0 0 1] ;

        % rotate 120 around z
        gh(2).g=[...
                0 1 0 0;...
                0 0 1 0;...
                1 0 0 0;...
                0 0 0 1] ;

        % rotate 240 around z
        gh(3).g=[...
                0 0 1 0;...
                1 0 0 0;...
                0 1 0 0;...
                0 0 0 1] ;

        % rotate 180 around x
        gh(4).g=[...
                1 0 0 0;...
                0 0 1 0;...
                0 1 0 0;...
                0 0 0 -1] ;

        % rotate 180 around y
        gh(5).g=[...
                0 0 1 0;...
                0 1 0 0;...
                1 0 0 0;...
                0 0 0 -1] ;

        % rotate 180 around dummy
        gh(6).g=[...
                0 1 0 0;...
                1 0 0 0;...
                0 0 1 0;...
                0 0 0 -1] ;

        % 3 axis 

        %reference
        gh(1).g3=[...
                1 0 0;...
                0 1 0;...
                0 0 1] ;

        % hkil -> ihkl
        gh(2).g3 = [...
                cosd(120) sind(120) 0;...
                -sind(120) cosd(120) 0;...
                0 0 1];

        % rotate -120 around z
        % hkil -> kihl
        gh(3).g3 = [...
                cosd(-120) sind(-120) 0;...
                -sind(-120) cosd(-120) 0;...
                0 0 1];

        % rotate 180 around hex axis 1 (// y in cart)
        gh(4).g3=[...
                -1 0 0;...
                0 1 0;...
                0 0 -1] ;
        % rotate 180 around hex axis 2
        gh(5).g3= gh(2).g3*gh(4).g3*gh(3).g3;
        % rotate 180 around hex axis 3
        gh(6).g3= gh(3).g3*gh(4).g3*gh(2).g3;

    otherwise
        disp('spacegroup not supported')
    end
end
