function hkil_reflections = gtGetReflections_sab(hkil)    
% from input hkil [h k i l], return matrix(n x 4) of all symmetry related
% reflections.  Uses gtGetHexagonalSymOp_sab modified from Risoe group

%get symmetry operators
load('parameters.mat');

if parameters.cryst.spacegroup==663 || parameters.cryst.spacegroup==194 || parameters.cryst.spacegroup==167
    symm = gtGetHexagonalSymOp_sab();
else
    disp('spacegroup not supported')
    return
end


%apply to input reflection
for i=1:length(symm)
    if size(hkil,2) == 4
        hkil_reflections(i,:) = hkil*symm(i).g;
    elseif size(hkil,2) == 3
        hkil_reflections(i,:) = hkil*symm(i).g3;
    end
end

hkil_reflections=unique(hkil_reflections, 'rows');

end