function cmd=gtGetARTCommand(executable)
% gtGetARTCommand(executable)
% returns the full path to the executable requested.
% executable can be with "rec_alg" or "seg2view"
%
% Usage:
% cmd=gtGetARTCommand('rec_alg')
% unix(cmd)
%
% This runs rec_alg...
%
% This supports Linux on Athlons (corals etc) and Mac Intel machines
% using 'computer' to determine machine type
  switch lower(executable)
    case 'rec_alg'
      switch lower(computer)
        case 'glnxa64'
          cmd='/data/id19/graintracking/matlab/zUtil_ART/rec_alg_GLNXA64';
        case 'maci'
          cmd ='~/matlab_graintracking/zUtil_ART/rec_alg_MACI';
        otherwise
          disp('Computer not recognised')
          cmd=[];
          help(mfilename)
      end
    case 'seg2view'
      switch lower(computer)
        case 'glnxa64'
          cmd='/data/id19/graintracking/matlab/zUtil_ART/seg2view_GLNXA64';
        case 'maci'
          cmd ='~/matlab_graintracking/zUtil_ART/seg2view_MACI';
        otherwise
          disp('Computer not recognised')
          cmd=[];
          help(mfilename)
      end
    otherwise
      disp('Command not recognised')
      cmd=[];
      help(mfilename)
  end

end

