function abs = gtAstraAbsorptionVolume(parameters)
% GTASTRAABSORPTIONVOLUME reconstruct absorption volume using 3D SIRT or 
% 2D FBP
%
% function abs = gtAstraAbsorptionVolume(parameters)
%
% Checks if absorption_stack.mat exists (will create it otherwise)
% Checks if absorption_mask.mat exists (will create it otherwise)
% Outputs reconstructed volume into file absorption.mat

if ~exist('parameters','var')
    load parameters
end

  

acq = parameters.acq;



projname = fullfile(acq.dir, 'absorption_stack.mat');

proj = [];
if exist(projname, 'file')
    check = inputwdefault('Absorption stack already exists - do you want to (re)-create it ? y/n', 'n');
    
    if strcmpi(check,'n')
        proj = load(projname);
    else
        proj = gtAstraPrepareAbsorptionStack(parameters);
    end
    
else
    proj = gtAstraPrepareAbsorptionStack(parameters);
end

switch parameters.rec.method
    case '3DART'
        abs = gtAstra3D([],[],[],proj);
    case '2DFBP'
        abs = gtAstra_FBP2D(parameters,proj);
end

end




