%find similar grains
%given the grain structure generated by sort_grains, containing positions
%and R-vectors, and the parameters files, containing pixel size data...

function output = gtFindSimilarGrains(g1, g2, parameters1, parameters2)

%read out data
for i=1:length(g1)
map1.R_vec(i,:)=g1{i}.R_vector;
map1.pos(i,:)=g1{i}.center;
end
for i=1:length(g2)
map2.R_vec(i,:)=g2{i}.R_vector;
map2.pos(i,:)=g2{i}.center;
end

switch parameters1.cryst.spacegroup
  case {225, 229} %cubic
    sym=gtGetCubicSymOp;
  case{663, 194} %hexagonal
    sym=gtGetHexagonalSymOp_sab;
    
%%%try producing symmetry operators in 3x3 format    
a=0
for i=1:6
test(i).g=[cosd(a) -sind(a) 0; sind(a) cosd(a) 0; 0 0 1];
%test2(i).g=[cosd(a) sind(a) 0; -sind(a) cosd(a) 0; 0 0 1];
a=a+60;
end
a=0
for i=7:12
test(i).g=[cosd(a) -sind(a) 0; sind(a) cosd(a) 0; 0 0 -1];
%test2(i).g=[cosd(a) sind(a) 0; -sind(a) cosd(a) 0; 0 0 -1];
a=a+60;
end
sym=test;
%%%end of bodge
    
  otherwise
    disp('This spacegroup not supported')
    return
end




%try to deal with shifts here.
map1.pos=map1.pos-repmat(mean(map1.pos,1), length(map1.pos), 1);
map2.pos=map2.pos-repmat(mean(map2.pos,1), length(map2.pos), 1);
%scale to pixelsize of map 1
map2.pos=map2.pos*parameters2.acq.pixelsize/parameters1.acq.pixelsize;




%go through grain map 1, looking for matches in grain map 2
output=[];
for i=1:length(map1.R_vec)
  
  %calculate misorientations
  misorientation=[];
  for j=1:length(map2.R_vec)
          
    g1=Rod2g(map1.R_vec(i,:));
    g2=Rod2g(map2.R_vec(j,:));
    %need to search symmetry equivilents for the minimum misorientation
    rot_offset=[];
    for k=1:length(sym)
      g1equiv = sym(k).g*g1;
      netg = inv(g1equiv)*g2;
      rot_offset(k) = acos((trace(netg)-1)/2);  
    end
  
    misorientation(j)=min(abs(rot_offset));
  end
  
  %calculate distances
  dif = map2.pos-repmat(map1.pos(i,:),size(map2.pos,1),1);
  distance = sqrt(sum((dif.^2),2));
  
i
pos=find(distance<70 & misorientation'<5*pi/180)
output(i).possibles=pos;
  output(i).dif=dif(pos,:);
  output(i).distance=distance(pos);
  
  output(i).misorientations=misorientation(pos);
  
  
end
  


keyboard



