function fsim = gtFsimDefaultParameters()

fsim.check_spot      = false;     % check for intensity in the FULL images in case no difspot can be found in database
fsim.omegarange      = 0.5;       % look in  +/- n degrees from predicted image position
fsim.MaxOmegaOffset  = 1;         % Maximum omega offset
fsim.bb_size         = [];        % default dimensions of ROI, read from the FULL images - if empty the zeropadded projection size will be used
fsim.assemble_figure = true;      % assemble the results of forward simulation into a full image saved in the grain%d_.mat file
fsim.display_figure  = true;      % automatically disabled when launched on OAR
fsim.Grayscale       = [-20 200]; % default colorlimits when visualizing diffraction spots
fsim.Rdist_factor    = 3;         % allow for multiple times Rdiststd in calulcation of lateral spot offset
fsim.bbsize_factor   = 2;         % allow for +/- times std difference in horizontal and vertical bb size
fsim.oversize        = 1.6;       % projections are zeropadded to twice their size before reconstruction
fsim.use_th          = true;      % use theoretically predicted diffraction angles for new detected spots
fsim.verbose         = false;     % tell which search criteria has failed
fsim.selected        = 5;         % Spots preselected for reconstruction have flag >= 5
fsim.included        = 4;         % Spots included into projection stack  (can be selected manually)

end
