

function a_axismap=gtAaxisCmap_sab
% make a colourmap according to c-axis orientation
% c_axis - calculated from r_vectors list as produced by gtReadGrains
% r_vectors -> c-axis -> phi/psi -> hsl -> rgb colormap
% use psi to give brightness; phi to give colour

%%%%%%%%%%%%%%on s interesse a l axe a
load('parameters.mat');
load r_vectors

 
all_hkils=[];
hkil = [...
    1 0 -1 0; ...
    ];
for i = 1:size(hkil,1)
    all_hkils = [all_hkils ; gtGetReflections_sab(hkil(i,:))];
end
% normalise hkls vector
% going to cartesian reciprocal space + normalisation of the cartesian
% space
for i=1:size(all_hkils)
    all_hkls(i,1)= all_hkils(i,1) + 0.5 * all_hkils(i,2);
    all_hkls(i,2)= 3^0.5/2 *all_hkils(i,2);
    all_hkls(i,3)= all_hkils(i,4);

    all_hkls(i,1)=all_hkls(i,1)*2/(sqrt(3)*parameters.cryst.latticepar(1));
    all_hkls(i,2)=all_hkls(i,2)*2/(sqrt(3)*parameters.cryst.latticepar(1));
    all_hkls(i,3)=all_hkls(i,3)/parameters.cryst.latticepar(3);
end
tmp = sqrt(sum((all_hkls.*all_hkls),2));
normalised_hkls = all_hkls./(repmat(tmp,1,3));
% unification des notations pour la suite
all_hkls = [];
all_hkls = all_hkils;


for i=1:size(r_vectors,1)
    g = Rod2g(r_vectors(i,2:4));
    all_normals = (g * normalised_hkls')';
    a_axis(i,1)=r_vectors(i,1);
    if all_normals(6,1)>=0
        a_axis(i,2)=all_normals(6,1);
        a_axis(i,3)=all_normals(6,2);
        a_axis(i,4)=all_normals(6,3);
    else
        a_axis(i,2)=all_normals(1,1);
        a_axis(i,3)=all_normals(1,2);
        a_axis(i,4)=all_normals(1,3);
    end
end


save a_axis a_axis % list of the c axis


psi=acosd(a_axis(:,4));
phi=atan2(a_axis(:,3), a_axis(:,2));



%get everything in degrees, and on the right interval
phi=phi*180/pi;
% %want all psi between 0 and 90
% psi(find(psi>90))=180-psi(find(psi>90));
% %if we change psi, should also change phi
% phi(find(psi>90))=phi(find(psi>90))+180;

dummy=find(psi>90);
psi(dummy)=180-psi(dummy);
%if we change psi, should also change phi
phi(dummy)=phi(dummy)+180;

phi(find(phi<0))=phi(find(phi<0))+360;
phi(find(phi>360))=phi(find(phi>360))-360;

%use hsl2rgb.m
%hue
h=phi/360;
%saturation
s=ones(size(h));
%lightness (white //z, black in x-y plane)
l=0.9-(0.8*(psi/90));

rgb=hsl2rgb([h s l]);

%add black background
a_axismap=zeros(size(rgb, 1)+1, 3);
a_axismap(2:end, :)=rgb;

%save the caxis colourmap
save a_axismap a_axismap