function vertices = hexagon(a,c,draw)

% create a hexagonal grid (radius <r>)

% apothem = c2 = r*sqrt(3)/2
cx=a*sqrt(3);
c2=cx/2;
v=0:60:360;
cv=a*cosd(v);
sv=a*sind(v);
x0 = 0*cx+cv;
y0 = 0*cx+sv;
z0 = repmat(-c/2,1,length(v));
z1 = repmat(+c/2,1,length(v));

vertices = [[x0;y0;z0],[x0;y0;z1]]';
vertices(7,:)=[];
vertices(end,:)=[];

if draw
    figure;
    line(x0,y0,z0);
    line(x0,y0,z1);
    hold on;
    plot3(x0,y0,z0,'r*')
    plot3(x0(1),y0(1),z0(1),'b*')

    axis equal;
    xlabel('x (100)')
    ylabel('y (010)')
    zlabel('z (001)')
end
% 
% 
% % hexagon made of hexagons
% figure;
% axis equal;
% for f=[1,2] % we test <f>!
%     for a=0:60:360
%         line(f*cx*cosd(a)+cv,f*cx*sind(a)+sv);
%     end
%     if f==2
%         for a=30:60:360
%             line(c2*cx*cosd(a)+cv,c2*cx*sind(a)+sv);
%         end
%     end
% end

% 
% xy=unique([x,y],'rows')
% 
% x=xy(:,1);
% y=xy(:,2);
% xx=[];
% yy=[];
% for i=1:3
%     p=convhull(x,y);
%     xx=[xx;x(p)]; % quick and dirty!
%     yy=[yy;y(p)];
%     x(p)=[];
%     y(p)=[];
% end
% at=atan2(xx,yy);
% [ax,ax]=sort(at);
% xx=xx(ax);
% yy=yy(ax);
% line(xx,yy,...
%     'marker','s',...
%     'color',[0,0,0]);
% % test some data points
% px=20*rand(500,1)-10;
% py=20*rand(500,1)-10;
% line(px,py,...
%     'marker','.',...
%     'markersize',4,...
%     'linestyle','none');
% ix=inpolygon(px,py,xx,yy);
% line(px(ix),py(ix),...
%     'marker','.',...
%     'linestyle','none',...
%     'color',[1,0,0]);

end