function cmap = gtIVPhexCmap(r_vectors, bodge)
% map = gtIVPhexCmap(r_vectors, bodge)

if ~exist('bodge','var') || isempty(bodge)
    bodge = 0; % degrees
end

cmap = [];
RD=[0 0 1];

% make some symmetry operators
% six fold rotation around z
for i=1:6
    a=(i-1)*60;
    symm(i).g3 = [...
        cosd(a) sind(a) 0;...
        -sind(a) cosd(a) 0;...
        0 0 1];
    % include the mirror
    symm(i+6).g3=[1 0 0; 0 -1 0; 0 0 1]*symm(i).g3;
end

map = zeros(length(r_vectors+1),3);

for i=1:length(r_vectors)
    
    g=Rod2g(r_vectors(i, 2:4));

    disp([num2str(bodge) ' degrees bodge here!'])
    g=[cosd(bodge) sind(bodge) 0; -sind(bodge) cosd(bodge) 0; 0 0 1]*g;
    
    % RD in cryst axes
    RDc = g*RD';
    % all equivilents by sym
    RDc_sym=[];
    for jj=1:12
        RDc_sym(jj, :)=(symm(jj).g3*RDc)';
    end
    RDc_sym=[RDc_sym; -RDc_sym];
    
    RDc_psi=acosd(RDc_sym(:,3));
    RDc_phi=rad2deg(atan2(RDc_sym(:,2), RDc_sym(:,1)));

    
    % pick equiv that is in out triangle
    ndx=find(RDc_psi<90 & RDc_phi>=60 & RDc_phi<90);
    
    % RD sym equivilent in the part of the crystal we are interested in
    RDp(i, :)=RDc_sym(ndx, :);
    
    % colourmap
    psi=RDc_psi(ndx);
    phi=RDc_phi(ndx);
    
    red=(90-psi)/90;
    green=(phi-60)/30;
    blue=(90-phi)/30;
    
    map(i+1, :)=[red green blue];
    
end

cmap = map;

end % end of function


    
    
    