function gtMakePoleFigure_hex(poles)
% make a pole figure on the given a list of poles.
% poles=[x y z, x2 y2 z2; ...]
% get poles from gtReadBoundariesStructure

parameters=[];
load('parameters.mat');

i=1;j=1;
figure
searchR=0.1; %was 0.05

%step size in pole figures
%inc=0.02;
inc=0.02;

for omega=0:inc:2*pi%/2 %around z-axis
  j=1;
  for eta=0:inc:pi/2 % out from z-axis 
    
    z=cos(eta);
    x=sin(eta)*cos(omega);
    y=sin(eta)*sin(omega);
    test_normal=[x y z];
    
    if 1%z>y %1
      angle_dev = acos((dot(poles, repmat(test_normal, size(poles,1), 1), 2)));
      density(i,j)=length(find(angle_dev<searchR));
      %density2(i,j)=length(find(angle_dev<0.08));
      %density3(i,j)=length(find(angle_dev<0.02));

    else
      density(i,j)=NaN;
    end
    
    j=j+1;
    
  end
  i=i+1;
end


%normalise density into smething meaningful
%total solid angle covered 4pi for a whole sphere
%If we have poles covering a whole sphere, random density is
random_density=(length(poles))*((searchR^2)/4); %pi's cancel
density=density./random_density;

%have: density as a function of omega and eta.  Can convert to x,y,z, and
%use surf.
%modify for steorographic projection
omega=0:inc:2*pi;%/2;%/4; %around z-axis
eta=0:inc:pi/2; %away from z axis

r=tan(eta/2);
[omega,r]=meshgrid(omega,r);
[x,y]=pol2cart(omega,r);

%figure(1)
surf(x,y,density')
hold on
shading('interp')
axis equal

% figure(2)
% surf(x,y,density2')
% hold on
% shading('interp')
% axis equal
% 
% figure(3)
% surf(x,y,density3')
% hold on
% shading('interp')
% axis equal




if parameters.cryst.spacegroup == 663
    uvw_poles_a=[0 0 0 2; ...
        1 1 -2 0; ...
        1 -1 0 0; ...
        1 -1 0 1; ...
        1 1 -2 2; ...
        -2 0 2 1; ...
        ];
else
    disp('this spacegroup is not impleted yes')
end


sym=gtGetHexagonalSymOp_sab; % plans qui diffractent
uvw_poles_final=[];
for i=1:size(uvw_poles_a,1)
 %i=1
  uvw_poles_hex=[];
  for j=1:size(sym,2)
    uvw_poles_hex(j,:)=uvw_poles_a(i,:)*sym(j).g;
  end  
    uvw_poles_hex=unique(uvw_poles_hex,'rows'); % a mettre ?
    
    for j=1:size(uvw_poles_hex,1)
        uvw_poles(j,1)= uvw_poles_hex(j,1) + 0.5 * uvw_poles_hex(j,2);
        uvw_poles(j,2)= 3^0.5/2 *uvw_poles_hex(j,2);
        uvw_poles(j,3)= uvw_poles_hex(j,4);
    end

 

    uvw_poles=[uvw_poles; -uvw_poles];
    uvw_poles_final=[ uvw_poles_final;uvw_poles];
  %uvw_poles=unique(uvw_poles,'rows'); % a mettre ? 

  %%%%%%%%%%%%%correct until here
  
  % hexagonal to cartesian
    
 
  %
  
om_uvw=atan2(uvw_poles(:,2), uvw_poles(:,1));

et_uvw=acos(uvw_poles(:,3)./(sqrt(sum(uvw_poles.*uvw_poles, 2))));
r_uvw=tan(et_uvw/2);
dummy=find(r_uvw>1);
r_uvw(dummy)=[];
om_uvw(dummy)=[];
[x_uvw,y_uvw]=pol2cart(om_uvw, r_uvw);
dummy=find(x_uvw<-1 | x_uvw>1 | y_uvw<-1 | y_uvw>1);
x_uvw(dummy)=[];
y_uvw(dummy)=[];

figure(1)
hold on
if i==1 ; plot3(x_uvw, y_uvw, ones(size(x_uvw))*(max(density(:))+1), 'ko'); end
if i==2 ; plot3(x_uvw, y_uvw, ones(size(x_uvw))*(max(density(:))+1), 'r*'); end
if i==3 ; plot3(x_uvw, y_uvw, ones(size(x_uvw))*(max(density(:))+1), 'g*'); end
if i==4 ; plot3(x_uvw, y_uvw, ones(size(x_uvw))*(max(density(:))+1), 'y*'); end
if i==5 ; plot3(x_uvw, y_uvw, ones(size(x_uvw))*(max(density(:))+1), 'b*'); end
if i>5 ; plot3(x_uvw, y_uvw, ones(size(x_uvw))*(max(density(:))+1), 'k*'); end

hold off

% figure(2)
% plot3(x_uvw, y_uvw, ones(size(x_uvw))*(max(density2(:))+1), 'k*')
% figure(3)
% plot3(x_uvw, y_uvw, ones(size(x_uvw))*(max(density3(:))+1), 'k*')

end
set(gca, 'XTickLabel','')
set(gca, 'YTickLabel','')
set(gca, 'GridLineStyle','none')
colorbar







