function rmap=gtRvectorCmap

% make a colormap from the r_vectors.  Requires tha tthe r_vectors.mat
% variable has been created - use gtReadGrains


if ~exist('r_vectors.mat', 'file')
    disp('Missing r_vectors.mat file - use gtReadGrains to create...')
    rmap=[];
    return
end

load r_vectors
% get the three components of the r-vector
rmap=r_vectors(:,2:4);
% scale to 0-1
rmap=rmap-min(rmap(:));
rmap=rmap/max(rmap(:));
% black background
rmap=[0 0 0; rmap];

