
function gtSSTCmap_new()
%make a color space for the Standard Stereographic Triangle

% try and adapt HSL model to SST

centre_pole=mean([0 0 1; 1/sqrt(3) 1/sqrt(3) 1/sqrt(3); 1/sqrt(2) 0 1/sqrt(2)]);
centre_pole=centre_pole/norm(centre_pole);



%analyse the pole data
figure
hold on
inc=0.01;
i=1;j=1;
    phimax=pi/4;
    psimax=atan(sqrt(2));
for phi=[0:inc:(phimax-inc) (phimax-inc)] %around z-axis
    j=1;
    for psi=[0:inc:(psimax+inc) psimax+inc] % out from z-axis - go slightly further to avoid gaps at edge of triangle

        z=cos(psi);
        x=sin(psi)*cos(phi);
        y=sin(psi)*sin(phi);
        
        %for a colour representation want two angles - phi (around z) and
        % alpha (around y)
        
        alpha=atan(x/z); % in sst alpha 0->pi/4
        
        % distance from centre pole
        angletocentre=acosd(dot([x,y,z],centre_pole));
        % this has range 0 - 31.65degrees
        
        if alpha<=pi/4
            rgb=[1-(alpha/(pi/4)) (alpha/(pi/4))*(1-(phi/(pi/4))) (alpha/(pi/4))*(phi/(pi/4))];
            % should this be here?
            % rgb=rgb/max(rgb);
        normval=max(max(rgb), 1+((max(rgb)-1)*angletocentre/14.5));
        rgb=rgb/normval;
        else
            rgb=[1-(alpha/(pi/4)) (alpha/(pi/4))*(1-(phi/(pi/4))) (alpha/(pi/4))*(phi/(pi/4))];
           % rgb=rgb/max(rgb);
                 normval=max(max(rgb), 1+((max(rgb)-1)*angletocentre/14.5));
        rgb=rgb/normval;
            rgb(find(rgb<0))=0;
            rgb(find(rgb>1))=1;
            %rgb=[1 1 1];
        end

        test_normal=[x y z];

%radius distorted for stereographic proj
r_patch=tan([psi/2 (psi+inc)/2]);
[phi_patch,r_patch]=meshgrid([phi phi+inc]',r_patch);
[x_patch,y_patch]=pol2cart(phi_patch,r_patch);
        

         p=patch(x_patch([1 2 4 3]), y_patch([1 2 4 3]), rgb);
        set(p, 'edgecolor', 'none')
        j=j+1;
    end
    i=i+1;
end

%add poles and tart up like gtMakePoleFigure
set(gca, 'XTickLabel','')
set(gca, 'YTickLabel','')
set(gca, 'GridLineStyle','none')
set(gca, 'Ycolor', 'w')
set(gca, 'Xcolor', 'w')

set(gca, 'xlim', [-0.02 sqrt(2)-1+0.045])
set(gca, 'ylim', [-0.025 0.3769])

if 0
        uvw_poles=[0 0 1; 1 0 1; 1 1 1;...
            2 0 1; 2 1 1; 2 2 1;...
            3 0 1; 3 1 1; 3 2 0; 3 2 1; 3 2 2; 3 3 1; 3 3 2;...
            4 0 1; 4 1 1; 4 2 1; 4 3 0; 4 3 1; 4 3 2; 4 3 3; 4 4 1; 4 4 3];

            sym = gtGetCubicSymOp;
    uvw_poles2=[];
    for i=1:length(sym)
        uvw_poles2=[uvw_poles2; uvw_poles*sym(i).g];
    end
    uvw_poles=[uvw_poles2; -uvw_poles2];
        dum=find(uvw_poles(:,2)>=0 & uvw_poles(:,2)<=uvw_poles(:,1) & uvw_poles(:,3)>=uvw_poles(:,1));
        uvw_poles=uvw_poles(dum, :);
        
            % plot these uvw/hkl poles
    phi_uvw=atan2(uvw_poles(:,2), uvw_poles(:,1));
    psi_uvw=acos(uvw_poles(:,3)./(sqrt(sum(uvw_poles.*uvw_poles, 2))));
    r_uvw=tan(psi_uvw/2);
    dummy=find(r_uvw>1);
    r_uvw(dummy)=[];
    phi_uvw(dummy)=[];
    [x_uvw,y_uvw]=pol2cart(phi_uvw, r_uvw);
    dummy=find(x_uvw<-1 | x_uvw>1 | y_uvw<-1 | y_uvw>1);
    x_uvw(dummy)=[];
    y_uvw(dummy)=[];

    plot(x_uvw, y_uvw, 'k*')
    
    
                text(0, 0-0.015, '(001)')
        text(0.366+0.01, 0.366-0.005, '(111)')
        text(0.4142-0.015, -0.015, '(101)')
        
        text(0.1213-0.04, 0.1213, '(114)')
        text(0.1583-0.04, 0.1583, '(113)')
        text(0.2247-0.04, 0.2247, '(112)')
        text(0.2808-0.04, 0.2808, '(223)')
        text(0.3052-0.045, 0.3052, '(334)')

        text(0.3845+0.01, 0.2884, '(434)')
        text(0.3901+0.01, 0.2601, '(323)')
        text(0.4000+0.01, 0.2000, '(212)')
        text(0.4077+0.01, 0.1359, '(313)')
        text(0.4105+0.01, 0.1026, '(414)')

        text(0.1231-0.02, -0.015, '(104)')
        text(0.1623-0.01, -0.015, '(103)')
        text(0.2361-0.015, -0.015, '(102)')
        text(0.3028-0.02, -0.015, '(203)')
        text(0.3333-0.01, -0.015, '(304)')

        text(0.2967+0.01, 0.1483, '(213)')
        text(0.2330+0.01, 0.1165, '(214)')
        text(0.3297+0.01, 0.1099, '(314)')
        text(0.3197+0.01, 0.2131, '(324)')
end

        %add a black border
       %line from 101 to 111 is z=x
line_phi=[0:0.01:pi/4 pi/4];
linex=cos(line_phi);
linez=linex;
liney=sin(line_phi);
line_points=[linex' liney' linez'];
%normalise
line_points=line_points./repmat(sqrt(sum(line_points.*line_points, 2)), 1, 3);
%convert to stereographic proj.
line_psi=acos(line_points(:,3));
line_r=tan(line_psi/2);
%stereographic projection x-y
[linex,liney]=pol2cart(line_phi', line_r);
plot([linex; 0; linex(1)], [liney; 0; liney(1)], 'k-')


%add a white patch to mask the rough outer edge of the triangle
xp=[linex; linex(end); 0.55; 0.55; linex(1)];
yp=[liney; 0.379; 0.379; 0; 0];
p=patch(xp, yp, 'w');
set(p, 'edgecolor', 'none')


