function gc = gtCrystSymOpCubic()
% GTCRYSTSYMOPCUBIC
%     gc = gtCrystSymOpCubic()
%     ------------------------
%
%     Gives the 24 crystal symmetry operators for cubic lattices.
%     The symmetry operators as tabulated from tabel 3.2 in Hansen et al.
%
%     They can be used with row or column vectors.  
%
%     OUTPUT
%       gc(i).g - structure array of the operator matrices (i=1:24)
%
%


gc(1).g  = [ 1  0  0 ;  0  1  0 ;  0  0  1];
gc(2).g  = [-1  0  0 ;  0  1  0 ;  0  0 -1];
gc(3).g  = [-1  0  0 ;  0 -1  0 ;  0  0  1];
gc(4).g  = [ 1  0  0 ;  0 -1  0 ;  0  0 -1];
gc(5).g  = [ 0  1  0 ;  0  0  1 ;  1  0  0];
gc(6).g  = [ 0 -1  0 ;  0  0  1 ; -1  0  0];
gc(7).g  = [ 0 -1  0 ;  0  0 -1 ;  1  0  0];
gc(8).g  = [ 0  1  0 ;  0  0 -1 ; -1  0  0];
gc(9).g  = [ 0  0  1 ;  1  0  0 ;  0  1  0];
gc(10).g = [ 0  0 -1 ;  1  0  0 ;  0 -1  0];
gc(11).g = [ 0  0 -1 ; -1  0  0 ;  0  1  0];
gc(12).g = [ 0  0  1 ; -1  0  0 ;  0 -1  0];
gc(13).g = [ 0  0 -1 ;  0 -1  0 ; -1  0  0];
gc(14).g = [ 0  0  1 ;  0 -1  0 ;  1  0  0];
gc(15).g = [ 0  0  1 ;  0  1  0 ; -1  0  0];
gc(16).g = [ 0  0 -1 ;  0  1  0 ;  1  0  0];
gc(17).g = [-1  0  0 ;  0  0 -1 ;  0 -1  0];
gc(18).g = [ 1  0  0 ;  0  0 -1 ;  0  1  0];
gc(19).g = [ 1  0  0 ;  0  0  1 ;  0 -1  0];
gc(20).g = [-1  0  0 ;  0  0  1 ;  0  1  0];
gc(21).g = [ 0 -1  0 ; -1  0  0 ;  0  0 -1];
gc(22).g = [ 0  1  0 ; -1  0  0 ;  0  0  1];
gc(23).g = [ 0  1  0 ;  1  0  0 ;  0  0 -1];
gc(24).g = [ 0 -1  0 ;  1  0  0 ;  0  0  1];

end % end of function