/*
 * internal_cell_copy.cpp
 *
 *  Created on: Jul 13, 2012
 *      Author: ben
 */

#include "internal_cell_defs.h"

void mexFunction( int nlhs, mxArray * plhs[], int nrhs, const mxArray * prhs[] )
{
  if (nrhs != 1) {
    mexErrMsgIdAndTxt("C_FUN:cell_exponent_wrong_argument",
        "Not enough arguments! you need to provide a cell array and a double");
  }
  if (!mxIsCell(prhs[0])) {
    mexErrMsgIdAndTxt("C_FUN:cell_exponent_wrong_argument",
        "The first argument should be a Cell array");
  }

  inner_assign<const double, const double> funcNonVect;
#if defined(__SSE2__) || defined(__SSE2_MATH__)
  inner_assign<const v2df, const v2df> func;
  cell_iteration_sse<true>(plhs[0], prhs[0], func, funcNonVect);
#else
  cell_iteration<true>(plhs[0], prhs[0], funcNonVect);
#endif
}



