/*
 * internal_cell_exponent.cpp
 *
 *  Created on: Jul 10, 2012
 *
 * Nicola Vigano', 2012, ID11 @ ESRF vigano@esrf.eu
 */

#include "internal_cell_defs.h"

void mexFunction( int nlhs, mxArray * plhs[], int nrhs, const mxArray * prhs[] )
{
  if (nrhs != 2) {
    mexErrMsgIdAndTxt("C_FUN:cell_exponent_wrong_argument",
        "Not enough arguments! you need to provide a cell array and a double");
  }
  if (!mxIsCell(prhs[0])) {
    mexErrMsgIdAndTxt("C_FUN:cell_exponent_wrong_argument",
        "The first argument should be a Cell array");
  }
  if (!mxIsDouble(prhs[1])) {
    mexErrMsgIdAndTxt("C_FUN:cell_exponent_wrong_argument",
        "The second argument should be a double containing the exponent");
  }
  const double exponent = *mxGetPr(prhs[1]);

  plhs[0] = (mxArray *) prhs[0];

  inner_pow<const double, const double> func(exponent);
  cell_iteration<false>(plhs[0], prhs[0], func);
}
