function answer=between(arg,a,b)
% FUNCTION BETWEEN logical operation
% function answer=between(arg, a, b)
%
% returns true if arg <= b && arg >= a
% arg may either be a scalar or a matrix of same size like a and b


if size(a) ~= size(b)
    mexc = MException('BETWEEN:wrong_input','input arguments need to be same size. Exiting...');
    throw(mexc);
    return
end

if ~isscalar(arg) && any(size(a) ~= size(arg))
    mexc = MException('BETWEEN:wrong_input','arg needs to be either a scalar or a matrix of same size as a and b!  Exiting...');
    throw(mexc);
    return
end

answer = false(size(a));
num_el = length(a(:));

if size(arg) == size(a)

    for ii = 1 : num_el 
        if (arg(ii) <= b(ii)) && (arg(ii) >= a(ii))
           answer(ii) = true;
        end
    end
    
else 

    for ii = 1 : num_el 
        if (arg <= b(ii)) && (arg >= a(ii))
           answer(ii) = true;
        end
    end
   
end