function [rows,ia,ib,neq,diff]=findDifferentRowIntoMatrix(a,b)
% intersect matrices
% [rows,ia,ib,diff]=findDifferentRowIntoMatrix(a,b)

% trasform to columns
if size(a,1) < size(a,2)
    a=a';
end
if size(b,1) < size(b,2)
    b=b';
end
if size(a,2)~=size(b,2) 
    error('The size in the second dimension of a and b must be equal.')
end

[rows,ia,ib]=intersect(a,b,'rows');


if isempty(rows)    
    % remove the last columns
    [rows2,ia2,ib2]=intersect(a(:,1:end-1),b(:,1:end-1),'rows');
    
    if isempty(rows2)
       disp('No intersection')
       noa=[];
       difa=[];
       difb=[];
       ne=[];
    else
       % find the differences
       difa=a;
       difa(ia2,:)=[];
       difb=b;
       difb(ib2,:)=[];
       % show the last column different
       noa=a(ia2,end); % last column
       nob=b(ib2,end); % last column
       rows=rows2;
       ia=ia2;
       ib=ib2;
       ne=[noa nob];
    end
else
    % find the differences
    difa=a;
    difa(ia,:)=[];
    difb=b;
    difb(ib,:)=[];
    
    noa=a(ia,:); % last column
    nob=b(ib,:); % last column
    ne=[noa nob];
end


[tmpa,inda]=intersect(a,difa,'rows');
[tmpb,indb]=intersect(b,difb,'rows');

if nargout == 4
   neq=ne; 
end
if nargout == 5
    neq=ne;
    if size(inda,1)==size(indb,1)
        diff=[tmpa inda tmpb indb];
    else
        diff=[tmpa inda];
    end
end



end