function [index,outlist] = findIndecesMultiCols(inlist,values,toll)
% FINDINDECESMULTICOLS  Finds values into a list with a tollerance
%     [index,outlist] = findIndecesMultiCols(inlist,values,toll)
%     ----------------------------------------------------------
%     INPUT:
%       inlist = <double> can be a matrix
%       value  = <double> can be a vector
%       toll   = <double> can be a vector {0.000001}
%
%     OUTPUT:
%       index   = indeces of values in inlist <double>
%       outlist = inlist(index,:) <double>
%
%     Version 002 04-09-2012 by LNervo


if ~exist('toll','var') || isempty(toll)
  toll = 0.000001;
end

ind = [];
for ii=1:length(values)
    if size(toll,2)==1
        disp(['x < ' num2str(values(ii,1)+toll(1)) ' & x > ' num2str(values(ii,1)-toll(1))])
        ind=[ind; find(inlist(:,1) < values(ii,1) + toll(1) & inlist(:,1) > values(ii,1) - toll(1))];
        
    elseif size(toll,2)==2
        
        disp(['x < ' num2str(values(ii,1)+toll(1)) ' & x > ' num2str(values(ii,1)-toll(1)) ' & y < ' num2str(values(ii,2)+toll(2)) ' & y > ' num2str(values(ii,2)-toll(2))])
        ind=[ind; find(inlist(:,1) < values(ii,1) + toll(1) & inlist(:,1) > values(ii,1) - toll(1) & ...
                       inlist(:,2) < values(ii,2) + toll(2) & inlist(:,2) > values(ii,2) - toll(2)) ];
    elseif size(toll,2)==3
        disp(['x < ' num2str(values(ii,1)+toll(1)) ' & x > ' num2str(values(ii,1)-toll(1)) ' & y < ' num2str(values(ii,2)+toll(2)) ' & y > ' num2str(values(ii,2)-toll(2)) ' & z < ' num2str(values(ii,3)+toll(3)) ' & z > ' num2str(values(ii,3)-toll(3))])
        ind=[ind; find(inlist(:,1) < values(ii,1) + toll(1) & inlist(:,1) > values(ii,1) - toll(1) & ...
                       inlist(:,2) < values(ii,2) + toll(2) & inlist(:,2) > values(ii,2) - toll(2) & ...
                       inlist(:,3) < values(ii,3) + toll(3) & inlist(:,3) > values(ii,3) - toll(3))];
    end
end
index=ind;

if nargout == 2
    outlist=inlist(ind,:);
end

end % end of function
