function [index,outlist] = findStringIntoCell(inlist,values,column)
% FINDSTRINGINTOCELL  Finds string into a cell structure in the specified column
%     [index,outlist] = findStringIntoCell(inlist,values,column)
%     ---------------------------------------------------
%     INPUT:
%       inlist = <cell> structure of string
%       values = <cell> of string - can be a vector
%       column = <double> {1}
%
%     OUTPUT:
%       index   = indeces of values in inlist <double>
%       outlist = inlist(index,:) <cell>
%
%     Version 002 04-09-2012 by LNervo


if ~exist('column','var') || isempty(column)
  column = 1;
end

ind = [];
for ii=1:size(values,1)
    for j=1:size(inlist,1)
        tmp=inlist{j,column};
        if strfind(tmp,values{ii})
            ind=[ind;j];
        end
    end
end
index=ind;

if nargout == 2
    outlist=inlist(ind,:);
end

end % end of function
