function deps = gtGetFunctionDeps(functionNames, deps, excludePattern)
% GTGETFUNCTIONDEPS  Returns dependecies of the given functions
%     deps = gtGetFunctionDeps(functionNames, deps, excludePattern)
%     -------------------------------------------------------------
%
%     INPUT:
%       functionNames  = 
%       deps           = 
%       excludePattern = 
%
%     OUTPUT:
%       deps = 
%
%     SUB-FUNCTIONS:
%[sub]- filterListing
%
%     Version 001.2 16-05-2012 by LNervo
%       Formatting and commenting
%

    if (~exist('deps', 'var'))
        deps = functionNames;
    else
        deps = unique(union(deps, functionNames));
    end

    if (~exist('excludePattern', 'var'))
        excludePattern = '';
    end

    for name = functionNames
        listing = depfun(name, '-toponly', '-quiet');
        listing = setdiff(listing, intersect(deps, listing));
        if (~isempty('excludePattern'))
            listing = filterListing(listing, excludePattern);
        end
        if (~isempty(listing))
            deps = gtGetFunctionDeps(listing, deps, excludePattern);
        end
    end

    %% 
    % sub-functions
    
    function listing = filterListing(listing, excludePattern)
        matches = regexp(listing, excludePattern);
        listing = listing(cellfun(@(x)isempty(x), matches) == 1);
    end

end % end of function
