function sublist = gtSubList(list, varargin)
%
% based on a list created using make_parameters / build_list,
% make a sublist suitable for gtModifyStructure, containing only the
% requested fields.
%
% input, for example: gtSubList(list.acq, 'name', 'dir', energy')
% output: sublist, a 3x2 cell for gtModifyStructure

% preallocate sublist
sublist=cell(length(varargin), 2);

for i=1:length(varargin)
    ndx=find(strcmp(list(:,1), varargin{i}));
    if ~isempty(ndx)
    sublist{i,1}=list{ndx, 1};
    sublist{i,2}=list{ndx, 2}; 
    else
        disp(sprintf('problem with input to gtSubList - field name %s not found in main list',  varargin{i}))
    end
end