%%%%%%%%%%%%%%%%%%%%%%%%%%%
% assemble B1 pencil scan %
%%%%%%%%%%%%%%%%%%%%%%%%%%%

% pmo 219
spot=6;

% spot bounding box [xmin ymin xsize ysize]
gtbb=[454 1200 699 450];
% number of rows (v direction)
rows=gtbb(4);
% number of columns (u direction)
cols=gtbb(3);

omegaimages=15;
gridzimages=53;
nspots=6;

tmp=zeros(rows,cols);
stack=zeros(rows,cols,gridzimages*omegaimages);
vol=zeros(rows,cols,gridzimages);

% collect the omega stepping images
%%%%%%%%%%
% step 1 %
%%%%%%%%%%
for slice=1:gridzimages
    disp(slice)
    for i=1:omegaimages
        imagendx=(omegaimages*(slice-1))+i+omegaimages*gridzimages*(spot-1);
        %imagendx=(15*(slice-1))+i;
        stackndx=(omegaimages*(slice-1))+i;
        stack(:,:,stackndx)=edf_read(sprintf('B1pencilscan_%04d.edf', imagendx), gtbb);
    end
end

% need to de-noise...
filtstack=zeros(size(stack));
for i=1:size(stack, 3);
    filtstack(:,:,i)=medfilt2(stack(:,:,i));
end
% ...and need a dark
dark=median(filtstack(:,:,[1:omegaimages:end, omegaimages:omegaimages:end]), 3);
% subtract from stack
for i=1:size(stack, 3)
    filtstack(:,:,i)=filtstack(:,:,i)-dark;
end

% sum these to make an integrated volume
minivol=zeros(rows,cols, omegaimages);
for i=1:gridzimages
    rndx=(1:omegaimages)+((i-1)*omegaimages);
    minivol=filtstack(:,:,rndx);
    minivol(minivol<0)=0;
    minivolmask=imdilate(minivol>5, ones(5,5,5));
    vol(:,:,i)=sum(minivol.*minivolmask, 3);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% collect the other pencil steps 2-7 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
vol2=zeros(rows,cols,gridzimages);
for step=2:7
    disp(step)
    tmpvol=zeros(rows,cols,gridzimages);
    for slice=1:gridzimages
        % which image
        ndx=(omegaimages*gridzimages*nspots)+(spot-1)*53+((step-2)*(gridzimages*nspots))+slice;
        tmpvol(:,:,slice)=edf_read(sprintf('B1pencilscan_%04d.edf', ndx), gtbb);
    end
    % need to de-noise...
    filttmpvol=zeros(size(tmpvol));
    for i=1:size(tmpvol, 3);
        filttmpvol(:,:,i)=medfilt2(tmpvol(:,:,i));
    end
    % prepare a dark
    dark=min(filttmpvol(:,:,[1 end]),[], 3);
    b=dark(1:5, :);
    b=sum(b(:));
    % subtract
    for i=1:size(tmpvol, 3);
        a=filttmpvol(1:5,:,i);
        scalefactor=sum(a(:))/b;
        scaleddark=dark*scalefactor;
        filttmpvol(:,:,i)=filttmpvol(:,:,i)-scaleddark;
    end

    vol2=vol2+filttmpvol;
end


volf=vol2+vol;
edf_write(volf,sprintf('spot%d_vol.edf',spot))

